﻿Public Class api
	Public Shared loginInfo As DataRow

	Friend Shared Function apiParam(_fct As String) As Collections.Specialized.NameValueCollection
		Dim apireq As New Collections.Specialized.NameValueCollection
		apireq.Add("fct", _fct)
		apireq.Add("guid", loginInfo("guid").ToString)

		Return apireq

	End Function


	Friend Shared Function apiCall(_params As Collections.Specialized.NameValueCollection) As DataTable
		Dim wc As New Net.WebClient
		Dim url As String = String.Format("https://{0}.aceproject.com/api1/", aceSettings.account)

		wc.Headers.Add("user-agent", String.Format("SampleUpload({0})", aceSettings.account))

		Dim b As Byte() = wc.UploadValues(url, _params)

		Dim ds As New DataSet
		Dim ms As New IO.MemoryStream(b)

		ds.ReadXml(ms)

		Dim dt = ds.Tables(0)
		apiValidate(dt, _params)

		Return ds.Tables(0)

	End Function

	Private Shared Sub apiValidate(_dt As DataTable,
						_params As Specialized.NameValueCollection)

		If _dt.TableName.ToLower = "dtAPIErrors".ToLower Then
			Console.WriteLine("")
			Console.WriteLine(String.Format("Error calling api ({0})", _params.Item("fct")))
			Console.WriteLine("     *****")
			For Each key As String In _params.Keys
				Console.WriteLine(String.Format("{0}: {1}", key, _params.Item(key)))
			Next
			Console.WriteLine("     *****")
			For Each dr As DataRow In _dt.Rows
				For Each col As DataColumn In _dt.Columns
					Console.WriteLine(String.Format("{0}: {1}", col.ColumnName, dr.Item(col.ColumnName)))
				Next
				Console.WriteLine("     *****")
			Next
		End If
	End Sub

End Class
