﻿Public Class aceProject
	Friend Shared Function addProject(_name As String) As DataRow
		Dim params = api.apiParam("createorcopyproject")
		params.Add("projectname", _name)

		Dim dt = api.apiCall(params)

		Return dt.Rows(0)

	End Function

	Friend Shared Function getProject(_id As Integer) As DataRow
		Dim params = api.apiParam("getprojects")
		params.Add("projectid", _id.ToString)

		Dim dt = api.apiCall(params)

		Return dt.Rows(0)
	End Function

	Friend Shared Function addTask(_pid As Integer, _name As String) As DataRow

		Dim params = api.apiParam("createtask")
		params.Add("projectid", _pid.ToString)
		params.Add("summary", _name)

		Dim dt = api.apiCall(params)

		Return dt.Rows(0)

	End Function


	Friend Shared Function addDocumentToTask(_taskId As Integer,
								  _tmpfile As String,
								  _file As String) As DataRow

		Dim apireq = api.apiParam("savetaskdocument")

		apireq.Add("taskid", _taskId.ToString)
		apireq.Add("filenametemp", _tmpfile)
		apireq.Add("filename", _file)

		Dim dt As DataTable = api.apiCall(apireq)

		Return dt.Rows(0)

	End Function

	Friend Shared Function uploadFile(_path As String) As String
		Dim wc As New Net.WebClient

		Dim url As String = String.Format("https://{0}.aceproject.com/upload.ashx", aceSettings.account)

		Dim resp = wc.UploadFile(url, _path)

		Dim s = System.Text.Encoding.Default.GetString(resp)

		'Split the json result.  You can use newtonsoft to get a clean key-value collection object.
		Dim nametemp = s.Split(","c)(2).Split(":"c)(1).Trim(""""c)

		Return nametemp

	End Function


	Friend Shared Function login() As DataRow
		Dim apireq As New Collections.Specialized.NameValueCollection
		apireq.Add("fct", "login")
		apireq.Add("accountid", aceSettings.account)
		apireq.Add("username", aceSettings.uid)
		apireq.Add("password", aceSettings.pwd)

		Return api.apiCall(apireq).Rows(0)

	End Function

End Class
